############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : fichier.php
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#
#
#########################################################################
#!/bin/sh
#Editeur.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

source Association_i18n.fr
source utils.tcl


#set basedir [file dir $argv0]
#lappend auto_path [file join $basedir Img1.2]
#package require Img
switch $tcl_platform(platform) {
    unix {
    load [file join Img1.2 libimg1.2.so]
    }
    windows {
    package require Img
    }
    }
###################"gestion du son
global sound
if {[catch {package require snack}]} {
set sound 0
} else {
set sound 1
}

# Construction des widgets de l'interface, gnr automatiquement par tkbuilder
. configure  -height 480 -width 640
frame .frame1 -background #ffff80 -height 480 -width 320
grid .frame1 -column 0 -row 0
listbox .frame1.list1 -background #c0c0c0 -height 10 -width 20 -yscrollcommand ".frame1.scroll1 set"
scrollbar .frame1.scroll1 -command ".frame1.list1 yview"
place .frame1.list1 -x 100 -y 60
place .frame1.scroll1 -x 227 -y 60 -height 172
label .frame1.menu3 -text $gettext(Edit1) -background #ffff80
place .frame1.menu3 -x 80 -y 40
label .frame1.categorie -text $gettext(Edit2)
place .frame1.categorie -x 140 -y 10
label .frame1.menu1 -text $gettext(Edit3) -background #ffff80
place .frame1.menu1 -x 80 -y 340
button .frame1.ajouter -text $gettext(Edit4)
place .frame1.ajouter -x 180 -y 420
button .frame1.supprimer -text $gettext(Edit5)
place .frame1.supprimer -x 100 -y 420
entry .frame1.text1
place .frame1.text1 -x 100 -y 380
frame .frame2 -background #ffff80 -height 480 -width 320
grid .frame2 -column 1 -row 0
label .frame2.menu4 -text $gettext(Edit6) -background #ffff80
place .frame2.menu4 -x 80 -y 40
label .frame2.image -background #ff80c0
place .frame2.image -height 130 -width 130 -x 100 -y 60
entry .frame2.text2
place .frame2.text2 -width 130 -x 100 -y 200
button .frame2.prec -text <<
place .frame2.prec -x 120 -y 230
button .frame2.suiv -text >>
place .frame2.suiv -x 180 -y 230



label .frame2.association -text $gettext(Edit0)
place .frame2.association -x 140 -y 10
button .frame2.ajouter2 -text $gettext(Edit4)
place .frame2.ajouter2 -x 245 -y 70
button .frame2.supprimer2 -text $gettext(Edit5)
place .frame2.supprimer2 -x 235 -y 130
label .frame2.menu5 -text $gettext(Edit7) -background #ffff80 -font {Arial 10}
place .frame2.menu5 -x 70 -y 270
entry .frame2.mot
place .frame2.mot -x 100 -y 290
label .frame2.menu6 -text $gettext(Edit8) -background #ffff80 -font {Arial 10}
place .frame2.menu6 -x 50 -y 320
entry .frame2.syllabe
place .frame2.syllabe -x 100 -y 340
label .frame2.menu61 -text $gettext(Edit9) -background #ffff80 -font {Arial 10}
place .frame2.menu61 -x 50 -y 360
entry .frame2.graphie
place .frame2.graphie -x 100 -y 380

################################################################"
#placement des widgets sons si posiible
if {$sound == 1} {
snack::sound s

label .frame2.menu7 -text $gettext(Edit10) -background #ffff80
place .frame2.menu7 -x 115 -y 420
snack::createIcons
button .frame2.b1 -bitmap snackPlay -command Play
button .frame2.b2 -bitmap snackPause -command Pause
button .frame2.b3 -bitmap snackStop -command Stop
button .frame2.b4 -bitmap snackRecord -command Record -fg red

place .frame2.b1 -x 110 -y 440
place .frame2.b2 -x 135 -y 440
place .frame2.b3 -x 160 -y 440
place .frame2.b4 -x 185 -y 440
}

# nom du fichier de catgorie,de l'image en cours,de l'tiquette en cours 
global categorie listdata ind ext total currentlist1 currentimg repbasecat
set ind 0
set total 0
set categorie ""
set currentlist1 ""
set ext .cat
set currentimg ""
set repbasecat ""


set f [open [file join $Home association.conf] "r"]
set tmp [gets $f]
set tmp [gets $f]
set tmp [gets $f]
set tmp [gets $f]
set tmp [gets $f]
set repbasecat [gets $f]
close $f


#ouverture de la fentre pour la gestion des images
proc openimg {} {

    global currentimg gettext
    toplevel .w1
    
    wm title .w1 $gettext(Edit11) 
    frame .w1.frame -background #ffff80 -height 480 -width 420
    pack .w1.frame
    listbox .w1.frame.list2 -yscrollcommand ".w1.frame.scroll2 set"
    scrollbar .w1.frame.scroll2 -command ".w1.frame.list2 yview"
    place .w1.frame.list2 -height 130 -width 130 -x 60 -y 50
    place .w1.frame.scroll2 -x 180 -y 50 -height 130
    label .w1.frame.img -background #ff80c0
    place .w1.frame.img -height 130 -width 130 -x 240 -y 50
    button .w1.frame.ok -text $gettext(Edit18) -command "setimage .w1"
    place .w1.frame.ok -x 140 -y 400
    button .w1.frame.annul -text $gettext(Edit19) -command {destroy .w1}
    place .w1.frame.annul -x 200 -y 400
    listbox .w1.frame.list3 -yscrollcommand ".w1.frame.scroll3 set"
    scrollbar .w1.frame.scroll3 -command ".w1.frame.list3 yview"
    place .w1.frame.list3 -height 130 -width 130 -x 240 -y 240
    place .w1.frame.scroll3 -x 360 -y 240 -height 130
    label .w1.frame.labl3 -text $gettext(Edit12) -background #ffff80
    place .w1.frame.labl3 -x 240 -y 210
    label .w1.frame.labl4 -text $gettext(Edit13) -background #ffff80
    place .w1.frame.labl4 -x 40 -y 260
    label .w1.frame.labl5 -text $gettext(Edit14) -background #ffff80 -font {Arial 10}
    place .w1.frame.labl5 -x 70 -y 300
    label .w1.frame.labl6 -text $gettext(Edit15) -background #ffff80 -font {Arial 10}
    place .w1.frame.labl6 -x 65 -y 320
    label .w1.frame.labl7 -text $gettext(Edit16) -background #ffff80 -font {Arial 10}
    place .w1.frame.labl7 -x 55 -y 340

    entry .w1.frame.recherche
    place .w1.frame.recherche -x 60 -y 280



    peuplelist2
    peuplelist3
    catch {
    image create photo image2 -file [file join images [.w1.frame.list2 get 0]]
    .w1.frame.img configure -image image2
    } 

    bind .w1 <Control-q> {destroy .w1}
    bind .w1.frame.list2 <ButtonRelease-1> "changeimage %x %y"
    bind .w1.frame.list3 <ButtonRelease-1> "changelist2 %x %y"
    bind .w1.frame.recherche <Return> "changelist3"

}
#######################################################
proc changelist3 {} {
set ext .gif
set ext2 .ppm
set ext3 .jpg
set ext4 .png
set jok *
set currenttext [.w1.frame.recherche get]
	if {$currenttext !=""} {
	.w1.frame.list2 delete 0 end
		catch {
		image create photo image2 -file [file join images blank.gif]
		.w1.frame.img configure -image image2
			foreach i [lsort [glob [file join images $jok$currenttext$jok$ext] [file join images $jok$currenttext$jok$ext2] [file join images $jok$currenttext$jok$ext3] [file join images $jok$currenttext$jok$ext4]]] {
			.w1.frame.list2 insert end [file tail $i]
			}
		}
	} else {
	peuplelist2
	}
}

proc changeimage {x y} {

    #global currentimg
    set curimg [.w1.frame.list2 get @$x,$y]
    catch {
    image create photo image2 -file [file join images $curimg]
    .w1.frame.img configure -image image2
    } 
}

proc changelist2 {x y} {
    global gettext repbasecat
    set ext ".cat"
    catch {
    image create photo image2 -file [file join images blank.gif]
    .w1.frame.img configure -image image2
    }
    set curcat [.w1.frame.list3 get @$x,$y]
       if {$curcat==$gettext(Edit17)} {
       peuplelist2
       } else {
       set f [open [file join $repbasecat $curcat$ext] "r"]
       set listimg [gets $f]
       close $f
       .w1.frame.list2 delete 0 end
           for {set i 0} {$i < [llength $listimg]} {incr i 1} {
           .w1.frame.list2 insert end [lindex [lindex $listimg $i] 0]
           }
       }
}


proc peuplelist1 {} {
    global ext repbasecat
    .frame1.list1 delete 0 end
     catch {foreach i [lsort [glob [file join $repbasecat *$ext]]] {
       .frame1.list1 insert end [file tail [string range $i 0 [expr [string length $i] - 5]]]
       }
    }
}

proc peuplelist2 {} {
   .w1.frame.list2 delete 0 end
   set ext .gif
set ext2 .ppm
set ext3 .jpg
set ext4 .png
      catch {
		foreach i [lsort [glob [file join images *$ext] [file join images *$ext2] [file join images *$ext3] [file join images *$ext4]]] {
     		.w1.frame.list2 insert end [file tail $i]
     		}
   	}
}

proc peuplelist3 {} {
    global gettext repbasecat
    .w1.frame.list3 delete 0 end
    .w1.frame.list3 insert end $gettext(Edit17)
     catch {foreach i [lsort [glob [file join $repbasecat *cat]]] {
       .w1.frame.list3 insert end [file tail [string range $i 0 [expr [string length $i] - 5]]]
       }
    }
}
 

peuplelist1

bind .frame2.image <Double-ButtonRelease-1> "openimg"
bind .frame1.ajouter <ButtonRelease-1> "ajoutecategorie"
bind .frame2.ajouter2 <ButtonRelease-1> "ajouteitem"
bind .frame1.supprimer <ButtonRelease-1> "supprimecategorie"
bind .frame1.list1 <Double-ButtonRelease-1> "capturelist1"
bind .frame2.prec <ButtonRelease-1> "precedent"
bind .frame2.suiv <ButtonRelease-1> "suivant"
bind .frame2.supprimer2 <ButtonRelease-1> "supprimeitem"
bind . <Destroy> "enregistre"


proc supprimeitem {} {
global ind total listdata currentimg categorie
    if {$categorie==""} {
    bell
    return
    }
enregistre
if {$total > 1} {
  set listdata [lreplace $listdata [expr $ind] [expr $ind]]
  set total [expr $total - 1]
     if {$ind > 0} {
     set ind [expr $ind - 1]
     } else {
     set ind 0
     }
    catch {
    image create photo image1 -file [file join images [lindex [lindex $listdata $ind] 0]]
    }
  .frame2.text2 delete 0 end
  .frame2.text2 insert 0 [lindex [lindex $listdata $ind] 1]
  .frame2.mot delete 0 end
  .frame2.mot insert 0 [lindex [lindex $listdata $ind] 2]
  .frame2.syllabe delete 0 end
  .frame2.syllabe insert 0 [lindex [lindex $listdata $ind] 3]
  .frame2.graphie delete 0 end
  .frame2.graphie insert 0 [lindex [lindex $listdata $ind] 4]
  .frame2.image configure -image image1
  set currentimg [lindex [lindex $listdata $ind] 0]
  enregistre
} else {
  bell
}
}

proc ajouteitem {} {
global ind total listdata currentimg categorie
  if {$categorie==""} {
  bell
  return
  }
enregistre
incr total 
set ind [expr $total - 1]
set currentimg blank.gif
lappend listdata {blank.gif vide}
  catch {
  image create photo image1 -file [file join images $currentimg]
  .frame2.image configure -image image1
  }
.frame2.text2 delete 0 end
.frame2.text2 insert 0 vide
.frame2.mot delete 0 end
.frame2.syllabe delete 0 end
.frame2.graphie delete 0 end
enregistre
}

proc getdata {} {
global ind listdata currentimg
set space " "
set currenttext [.frame2.text2 get]
set currentmot [.frame2.mot get]
set currentsyllabe [.frame2.syllabe get]
set currentgraphie [.frame2.graphie get]
set liste \173$currentimg\175\040\173$currenttext\175\040\173$currentmot\175\040\173$currentsyllabe\175\040\173$currentgraphie\175
set listdata [lreplace $listdata [expr $ind] [expr $ind] $liste]
}

proc setimage {wind} {
global ind listdata currentimg
set currentimg [$wind.frame.list2 get active]
catch {
image create photo image1 -file [file join images $currentimg]
.frame2.image configure -image image1
}
destroy $wind
}


proc precedent {} {
global ind categorie listdata currentimg
if {$categorie!=""} {
    enregistre
    if {$ind > 0} {
    set ind [expr $ind - 1]
    catch {
    image create photo image1 -file [file join images [lindex [lindex $listdata $ind] 0]]
    }
    .frame2.text2 delete 0 end
    .frame2.text2 insert 0 [lindex [lindex $listdata $ind] 1]
    .frame2.mot delete 0 end
    .frame2.mot insert 0 [lindex [lindex $listdata $ind] 2]
    .frame2.syllabe delete 0 end
    .frame2.syllabe insert 0 [lindex [lindex $listdata $ind] 3]
    .frame2.graphie delete 0 end
    .frame2.graphie insert 0 [lindex [lindex $listdata $ind] 4]
    .frame2.image configure -image image1
    set currentimg [lindex [lindex $listdata $ind] 0]
    } else {
    bell
    }
}
}

proc suivant {} {
global ind categorie total listdata currentimg
if {$categorie!=""} {
    enregistre
    if {$ind < $total - 1} {
    incr ind
      catch {
      image create photo image1 -file [file join images [lindex [lindex $listdata $ind] 0]]
      }
    .frame2.text2 delete 0 end
    .frame2.text2 insert 0 [lindex [lindex $listdata $ind] 1]
    .frame2.mot delete 0 end
    .frame2.mot insert 0 [lindex [lindex $listdata $ind] 2]
    .frame2.syllabe delete 0 end
    .frame2.syllabe insert 0 [lindex [lindex $listdata $ind] 3]
    .frame2.graphie delete 0 end
    .frame2.graphie insert 0 [lindex [lindex $listdata $ind] 4]
    .frame2.image configure -image image1
    set currentimg [lindex [lindex $listdata $ind] 0]
    } else {
    bell
    }
}
}

proc enregistre {} {
global listdata categorie ext repbasecat
    if {$categorie != ""} {
    getdata
    set f [open [file join $repbasecat $categorie$ext] "w"]
    puts $f $listdata
    close $f
   }
}


proc capturelist1 {} {
global currentlist1
enregistre
set currentlist1 [.frame1.list1 get active]
ouvrecategorie
}

proc ouvrecategorie {} {
global categorie listdata total ind currentlist1 currentimg ext repbasecat
set ind 0
set total 0
  if {$currentlist1!=""} {
  set categorie $currentlist1
  .frame2.association configure -text $categorie
    catch {
    set f [open [file join $repbasecat $categorie$ext] "r"]
    set listdata [gets $f]
    close $f
    set total [llength $listdata] 
    } 
      if {$total!=0} {
      set currentimg [lindex [lindex $listdata 0] 0]
        catch {
        image create photo image1 -file [file join images [lindex [lindex $listdata 0] 0]]
        }
      .frame2.text2 delete 0 end
      .frame2.text2 insert 0 [lindex [lindex $listdata 0] 1]
      .frame2.mot delete 0 end
      .frame2.mot insert 0 [lindex [lindex $listdata 0] 2]
      .frame2.syllabe delete 0 end
      .frame2.syllabe insert 0 [lindex [lindex $listdata 0] 3]
      .frame2.graphie delete 0 end
      .frame2.graphie insert 0 [lindex [lindex $listdata 0] 4]
      .frame2.image configure -image image1
      }
   } else {
   bell
   }
}

proc supprimecategorie {} {
global currentlist1 categorie ext repbasecat
set categ [.frame1.text1 get]
  if {$categ==""} {
  bell
  return
  }
enregistre
  catch {[file delete [file join $repbasecat $categ$ext]]}
peuplelist1
set currentlist1 ""
set categorie ""
.frame2.association configure -text Associations
.frame1.text1 delete 0 end
.frame2.text2 delete 0 end
}

proc ajoutecategorie {} {
global ext listdata categorie currentlist1 gettext repbasecat
set categ [.frame1.text1 get]
  if {$categ==""} {
  bell
  return
  }
enregistre
set categ [.frame1.text1 get]
    if {[catch {set f [open [file join $repbasecat $categ$ext] "w"]}]} {
    bell
    return
    } else {
    set listdata {{blank.gif vide}}
    puts $f $listdata
    close $f
    peuplelist1
    set currentlist1 ""
    set categorie ""
   .frame2.association configure -text $gettext(Edit0)
   .frame1.text1 delete 0 end
   .frame2.text2 delete 0 end
   }
}

#########################
#procdures pour le son

proc Record {} {
global currentimg gettext repbasecat
if {$currentimg !="" && $currentimg !="blank.gif"} {
   set ext .wav
   set son [lindex [split $currentimg .] 0] 
   s stop
   s configure -file [file join $repbasecat $son$ext]
   s record
   set ::op r
   .frame2.b1 configure -relief raised
   .frame2.b4 configure -relief groove
    } else {
    set answer [tk_messageBox -message $gettext(Erreur5) -type ok -icon info] 
  }

}

proc Play {} {
global currentimg gettext repbasecat
if {$currentimg !="" && $currentimg !="blank.gif"} {
    set ext .wav
    set son [lindex [split $currentimg .] 0] 
    s stop
  if {[file exists [file join $repbasecat $son$ext]]} {
    catch {
      s configure -file [file join $repbasecat $son$ext]
      s play -command Stop
      set ::op p
      } 
    .frame2.b1 configure -relief groove
    .frame2.b4 configure -relief raised
    .frame2.b2 configure -relief raised
    }
    } else {
    set answer [tk_messageBox -message $gettext(Erreur5) -type ok -icon info] 
    }
}

proc Stop {} {
 s stop
 set ::op s
 .frame2.b1 configure -relief raised
 .frame2.b4 configure -relief raised
 .frame2.b2 configure -relief raised
}

proc Pause {} {
 s pause
  if {$::op != "s"} {
     if {[.frame2.b2 cget -relief] == "raised"} {
	 .frame2.b2 configure -relief groove
       } else {
	 .frame2.b2 configure -relief raised
       }
  }
}




















