############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : fichier.php
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#
#
#########################################################################
#!/bin/sh
#gestionson.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}


source Association_i18n.fr
source utils.tcl

global gettext

#wm resizable . 0 0
. configure -background #ffff80 
set font {Arial 16}
text .text -yscrollcommand ".scroll set" -setgrid true \
	-width 60 -height 24 -font $font -wrap word -background #ffff80 
scrollbar .scroll -command ".text yview"
pack .scroll -side right -fill y
pack .text -expand yes -fill both

    set bold "-background #43ce80 -relief raised -borderwidth 1"
    set normal "-background {} -relief flat"
for {set i 1} {$i < 9} {incr i 1} {
checkbutton .b$i -text $gettext(Son) -variable son$i -relief flat -background #ffff80 -font {Arial 16}
#bind .b$i <1> "enregistre"
}

.text insert end \
$gettext(Exo1)
.text window create current -window .b1
.text insert end \n\n
.text insert end \
$gettext(Exo2)
.text window create current -window .b2
.text insert end \n\n
.text insert end \
$gettext(Exo3)
.text window create current -window .b3
.text insert end \n\n
.text insert end \
$gettext(Exo5)
.text window create current -window .b4
.text insert end \n\n
.text insert end \
$gettext(Exo6)
.text window create current -window .b5
.text insert end \n\n
.text insert end \
$gettext(Exo7)
.text window create current -window .b6
.text insert end \n\n
.text insert end \
$gettext(Exo8)
.text window create current -window .b7
.text insert end \n\n
.text insert end \
$gettext(Exo10)
.text window create current -window .b8
.text insert end \n\n

global son
set son ""

catch {
set f [open [file join $Home son.conf] "r"]
set son [gets $f]
close $f
}

for {set i 1} {$i < 9} {incr i 1} {
if {[lindex $son [expr $i - 1]]==1} {
.b$i select
}
}


bind . <Destroy> "enregistre"


.text mark set insert 0.0
.text configure -state disabled


proc enregistre {} {
global Home
variable son1 
variable son2 
variable son3 
variable son4 
variable son5 
variable son6 
variable son7 
variable son8 
lappend listeson $son1
lappend listeson $son2
lappend listeson $son3
lappend listeson $son4
lappend listeson $son5
lappend listeson $son6
lappend listeson $son7
lappend listeson $son8

set f [open [file join $Home son.conf] "w"]
puts $f $listeson
close $f
exit
}










