############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : fichier.php
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#
#
#########################################################################
#!/bin/sh
#utils.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

#if {[catch {package require Img}]} {
#tk_messageBox -message "Veuillez installer le package Img version AbulEdu pour les filtres graphiques." -type ok
#}
switch $tcl_platform(platform) {
    unix {
    load [file join Img1.2 libimg1.2.so]
    }
    windows {
    package require Img
    }
    }
global basedir Home LogHome
set basedir [file dir $argv0]
cd $basedir
if {$env(HOME) == "c:\\"} {
set Home $basedir
} else {
set Home [file join $env(HOME) leterrier association]
}

set f [open [file join $Home repert.conf] "r"]
set repert [gets $f]
close $f
if {$repert == 1} {
set Home $basedir
}


switch $tcl_platform(platform) {
    unix {
	set LogHome [file join /var leterrier association]
    }
    windows {
	set LogHome [file join association Log]
    	}
}

if {$tcl_platform(user) != ""} {
     set user [file join $LogHome $tcl_platform(user).log]
     } else {
     set user [file join $LogHome association.log]
     }

