############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : fichier.php
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#
#
#########################################################################
#!/bin/sh
#Rglages.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

source Association_i18n.fr
source utils.tcl

global gettext

# Construction des widgets de l'interface, gnr automatiquement par tkbuilder
#pour la gestion des utilisateurs sous les tx, prvoir l'utilisation de $tcl_platform(user)
. configure  -height 480 -width 640
frame .frame1 -background #ffff80 -height 480 -width 640
grid .frame1 -column 0 -row 0
listbox .frame1.list1 -background #c0c0c0 -height 10 -width 20 -yscrollcommand ".frame1.scroll1 set"
scrollbar .frame1.scroll1 -command ".frame1.list1 yview"
place .frame1.list1 -x 100 -y 60
place .frame1.scroll1 -x 227 -y 60 -height 172
label .frame1.menu3 -text $gettext(Regl1) -background #ffff80
place .frame1.menu3 -x 40 -y 40
label .frame1.categorie -text $gettext(Edit2) 
place .frame1.categorie -x 140 -y 10
button .frame1.ferm -text $gettext(Regl2) -command {destroy .} -font {Arial 10}
place .frame1.ferm -x 580 -y 440
listbox .frame1.list2 -background #c0c0c0 -height 10 -width 20 -yscrollcommand ".frame1.scroll2 set"
scrollbar .frame1.scroll2 -command ".frame1.list2 yview"
place .frame1.list2 -x 380 -y 60
place .frame1.scroll2 -x 507 -y 60 -height 172
button .frame1.log -text $gettext(Regl3) -command {initbilan} -font {Arial 10}
place .frame1.log -x 260 -y 440
label .frame1.menu4 -text $gettext(Regl4) -background #ffff80
place .frame1.menu4 -x 370 -y 40
label .frame1.police -text $gettext(Regl5)
place .frame1.police -x 440 -y 10


global sound
set sound 0
if {[catch {package require snack}]} {
set sound 0
} else {
button .frame1.son -text $gettext(Regl6) -command {passon} -font {Arial 10}
place .frame1.son -x 440 -y 440
set sound 1
}


button .frame1.discr1 -text $gettext(Regl7) -command {discr1} 
place .frame1.discr1 -x 110 -y 290
label .frame1.lab10 -text $gettext(Regl8) -background #ffff80 -font {Arial 10}
place .frame1.lab10 -x 60 -y 270
label .frame1.lab11 -text $gettext(Regl9) -font {Arial 10} -background #ffff80 
place .frame1.lab11 -x 60 -y 320
entry .frame1.pho1 -width 8
place .frame1.pho1 -x 60 -y 340
label .frame1.lab12 -text $gettext(Regl10) -font {Arial 10} -background #ffff80 
place .frame1.lab12 -x 60 -y 360
entry .frame1.pho2 -width 24
place .frame1.pho2 -x 60 -y 380


button .frame1.discr2 -text $gettext(Regl7) -command {discr2} 
place .frame1.discr2 -x 410 -y 290
label .frame1.lab20 -text $gettext(Regl11) -background #ffff80 -font {Arial 10}
place .frame1.lab20 -x 360 -y 270
label .frame1.lab21 -text $gettext(Regl12) -font {Arial 10} -background #ffff80 
place .frame1.lab21 -x 360 -y 320
entry .frame1.let1 -width 8
place .frame1.let1 -x 360 -y 340
label .frame1.let12 -text $gettext(Regl13) -font {Arial 10} -background #ffff80 
place .frame1.let12 -x 360 -y 360
entry .frame1.let2 -width 24
place .frame1.let2 -x 360 -y 380

global user categorie son listdata police listdata2 repbasecat

set categorie ""
set police ""
set son 1
set listdata ""
set listdata2 ""
set repbasecat ""

catch {
set f [open [file join $Home association.conf] "r"]
set categorie [gets $f]
set police [gets $f]
set son [gets $f]
set listdata [gets $f]
set listdata2 [gets $f]
set repbasecat [gets $f]
close $f
}

if {$sound == 1 } {
if {$son == 1} {
.frame1.son configure -text $gettext(Regl14)
} else {
.frame1.son configure -text $gettext(Regl15)
}
}


if {$categorie != "none" && $categorie != "" && $categorie !=$gettext(Regl16)} {
set categorie [lindex [split $categorie .] 0]
.frame1.categorie configure -text $categorie}

if {$police != "none" && $police != ""} {
.frame1.police configure -font \173$police\175\04016
} else {
.frame1.police configure -font {Arial 20}
}

if {$listdata == "none" || $listdata == ""} {
set listdata {un on um nu}
.frame1.pho1 insert end un
.frame1.pho2 insert end "on um nu"
} else {
.frame1.pho1 insert end [lindex $listdata 0]
for {set i 1} {$i <= [llength $listdata]} {incr i 1} {
.frame1.pho2 insert end [lindex $listdata $i]\040
}
}

if {$listdata2 == "none" || $listdata2 == ""} {
set listdata2 {i l j}
.frame1.let1 insert end i
.frame1.let2 insert end "l j"
} else {
.frame1.let1 insert end [lindex $listdata2 0]
for {set i 1} {$i <= [llength $listdata2]} {incr i 1} {
.frame1.let2 insert end [lindex $listdata2 $i]\040
}
}

###########################################################"
proc discr1 {} {
global gettext Home
set types {
	{"Discrimination 1"		{.di1}	}
         }
catch {set file [tk_getOpenFile -initialdir $Home -filetypes $types]}

if {[catch { set f [open [file join $file] "r" ] }] } {
 
      set answer [tk_messageBox -message $gettext(Erreur) -type ok -icon info] 
      
} else {
set list [gets $f]
close $f
.frame1.pho1 delete 0 end
.frame1.pho2 delete 0 end

.frame1.pho1 insert end [lindex $list 0]
for {set i 1} {$i < [llength $list]} {incr i 1} {

.frame1.pho2 insert end [lindex $list $i]\040
}
}
}


proc discr2 {} {
global gettext Home
set types {
	{"Discrimination 2"		{.di2}	}
         }
catch {set file [tk_getOpenFile -initialdir $Home -filetypes $types]}

if {[catch { set f [open [file join $file] "r" ] }] } {
 
      set answer [tk_messageBox -message $gettext(Erreur) -type ok -icon info] 
      
} else {
set list [gets $f]
close $f

.frame1.let1 delete 0 end
.frame1.let2 delete 0 end

.frame1.let1 insert end [lindex $list 0]
for {set i 1} {$i < [llength $list]} {incr i 1} {

.frame1.let2 insert end [lindex $list $i]\040
}
}
}


proc passon {} {
global son gettext
if {$son == 1} {
set son 0
.frame1.son configure -text $gettext(Regl15)
} else {
set son 1
.frame1.son configure -text $gettext(Regl14)
}
}

proc peuplelist1 {} {
global repbasecat
    set ext .cat
    .frame1.list1 delete 0 end
    .frame1.list1 insert end aucune
 catch {foreach i [lsort [glob [file join $repbasecat *$ext]]] {
    .frame1.list1 insert end [file tail [string range $i 0 [expr [string length $i] - 5]]]
    }}
}


proc peuplelist2 {} {
    .frame1.list2 delete 0 end
set listedebonnespolices {Arial {Arial Black} courier {Cataneo BT} helvetica {Lucida Handwriting} times {Times New Roman}}
foreach i [lsort [font families]] {
      if {[lsearch $listedebonnespolices $i] != -1} {
        .frame1.list2 insert end $i
     }   
    }
}

peuplelist1
peuplelist2


bind .frame1.list1 <Double-ButtonRelease-1> "capturelist1"
bind .frame1.list2 <Double-ButtonRelease-1> "capturelist2"
bind . <Destroy> "enregistre"

proc enregistre {} {
global categorie police son disc1 disc2 gettext Home repbasecat
set ext .cat

set bonnereponse1 [.frame1.pho1 get]
set reponse1 [.frame1.pho2 get]
if {[string length $bonnereponse1] > 9} {
set tmp [string range $bonnereponse1 0 8]
set bonnereponse1 $tmp
}
for {set i 0} {$i < [llength $reponse1]} {incr i 1} {
if {[string length [lindex $reponse1 $i]] > 9} {
set tmp [string range [lindex $reponse1 $i] 0 8]
set reponse1 [lreplace $reponse1 $i $i $tmp]
}
}
######################################"""
set bonnereponse2 [string index [.frame1.let1 get] 0]
set reponse2 [.frame1.let2 get]

for {set i 0} {$i < [llength $reponse2]} {incr i 1} {
set tmp [string index [lindex $reponse2 $i] 0]
set reponse2 [lreplace $reponse2 $i $i $tmp]
}



###############################""

set f [open [file join $Home association.conf] "w"]


if {$categorie != "" && $categorie !=$gettext(Regl16) && $categorie !="none" } {
    puts $f [file join $categorie$ext]
    } else {
    puts $f "none"
    }

if {$police != ""} {
    puts $f $police
    } else {
    puts $f "none"
    }

puts $f $son
if {$bonnereponse1 != "" && $reponse1 != ""} {
    
    set list [concat $bonnereponse1 $reponse1]
    puts $f $list
    } else {
    puts $f "none"
    }

if {$bonnereponse2 != "" && $reponse2 != ""} {
    
    set list [concat $bonnereponse2 $reponse2]
    puts $f $list
    } else {
    puts $f "none"
    }
puts $f $repbasecat

close $f
}



proc capturelist1 {} {
global categorie
set categorie [.frame1.list1 get active]
.frame1.categorie configure -text $categorie
update
}



proc capturelist2 {} {
global police
set police [.frame1.list2 get active]
.frame1.police configure -font \173$police\175\04016
}

proc initbilan {} {
global LogHome
set ext .log
set list ""
catch {
foreach i [glob [file join $LogHome *$ext]] {
lappend list $i
}
for {set i 0} {$i < [llength $list]} {incr i 1} {
file delete [file join [lindex $list $i]]
}
}
}